searchNodes=[{"doc":"Constraint satisfaction problem definition &amp; solver interface.Use solve/2 for solving the csp. You can generate example CSPs with Csp.Problems module functions. For constructing your own CSPs, you can use helpers from Csp.Domains and Csp.Constraint. You can specify custom constraints by implementing Csp.Constraint protocol.Additionally, you can test some example problems with the provided escript CLI.","ref":"Csp.html","title":"Csp","type":"module"},{"doc":"Returns a list of variables from assignmnet that violate constraints in csp.","ref":"Csp.html#conflicted/2","title":"Csp.conflicted/2","type":"function"},{"doc":"Checks if (possibly partial) assignment satisfies all constraints in csp, for which it has enough assigned variables.","ref":"Csp.html#consistent?/2","title":"Csp.consistent?/2","type":"function"},{"doc":"Returns a list of all constraints in csp that have variable as one of their arguments.","ref":"Csp.html#constraints_on/2","title":"Csp.constraints_on/2","type":"function"},{"doc":"Returns a count of conflicts with assignment in csp, i.e. constraints that the assignment breaks.","ref":"Csp.html#count_conflicts/2","title":"Csp.count_conflicts/2","type":"function"},{"doc":"Returns a value for variable that will produce the minimal number of conflicts in csp with assignment.","ref":"Csp.html#min_conflicts_value!/3","title":"Csp.min_conflicts_value!/3","type":"function"},{"doc":"Orders values from variable's domain by number of violated constraints the variable participates in in the assignment for csp.fun()","ref":"Csp.html#order_by_conflicts/3","title":"Csp.order_by_conflicts/3","type":"function"},{"doc":"Solves a CSP.OptionsThe following opts are supported:method, can be one of the following::backtracking - backtracking search, selected by default:min_conflicts - min-conflicts algorithm with tabu search:ac3 - AC-3 algorithm followed by backtracking:brute_force - brute-force search.You can pass options to backtracking (see Csp.Backtracking.solve/2 docs), min-conflicts (Csp.MinConflicts.solve/2), or brute-force (see Csp.Searcher.brute_force/2) in this function's opts.","ref":"Csp.html#solve/2","title":"Csp.solve/2","type":"function"},{"doc":"Checks if assignment solves csp.","ref":"Csp.html#solved?/2","title":"Csp.solved?/2","type":"function"},{"doc":"","ref":"Csp.html#t:assignment/0","title":"Csp.assignment/0","type":"type"},{"doc":"","ref":"Csp.html#t:constraint/0","title":"Csp.constraint/0","type":"type"},{"doc":"","ref":"Csp.html#t:domain/0","title":"Csp.domain/0","type":"type"},{"doc":"","ref":"Csp.html#t:solve_result/0","title":"Csp.solve_result/0","type":"type"},{"doc":"","ref":"Csp.html#t:solver_status/0","title":"Csp.solver_status/0","type":"type"},{"doc":"","ref":"Csp.html#t:t/0","title":"Csp.t/0","type":"type"},{"doc":"","ref":"Csp.html#t:value/0","title":"Csp.value/0","type":"type"},{"doc":"","ref":"Csp.html#t:variable/0","title":"Csp.variable/0","type":"type"},{"doc":"Pure AC-3 algorithm implementation.Also provides reduce/3 helper that can be used as an inference part of search algorithms.","ref":"Csp.AC3.html","title":"Csp.AC3","type":"module"},{"doc":"Reduces the csp with AC-3.Accepts csp with assignment (map from variables to their assigned values), and a list of unassigned variables.Compared to solve/2, apart from tracking the assignment, it also uses simplified version of domain reduction for constraint: it doesn't attempt to track affected constraints when reducing some constraint's domain.Returns :no_solution if an inconsistency is detected, or a tuple of {:ok, csp, assignment, unassigned}, where domains of csp are reduced, assignment is amended with inferred variable assignments, and unassigned list is updated to reflect those assignment changes.","ref":"Csp.AC3.html#reduce/3","title":"Csp.AC3.reduce/3","type":"function"},{"doc":"Tries to solve csp with AC-3 algorithm, applying node and arc consistency.Only considers unary and binary constraints; will skip n-ary constraints where n &gt; 2.Returns a tuple {status, csp}.The returned csp will possibly have reduced domains. If all variables have domain length of 1, we found a solution (:solved status is returned). If any variable has a domain length of 0, we proved that csp is not solvable, and :no_solution status is returned. If neither of those conditions is true, :reduced status is returend, irrespective of any actual domain reduction occuring.","ref":"Csp.AC3.html#solve/1","title":"Csp.AC3.solve/1","type":"function"},{"doc":"","ref":"Csp.AC3.html#t:domain_reduction/0","title":"Csp.AC3.domain_reduction/0","type":"type"},{"doc":"","ref":"Csp.AC3.html#t:reduce_result/0","title":"Csp.AC3.reduce_result/0","type":"type"},{"doc":"","ref":"Csp.AC3.html#t:unassigned/0","title":"Csp.AC3.unassigned/0","type":"type"},{"doc":"Backtracking algorithm implementation.","ref":"Csp.Backtracking.html","title":"Csp.Backtracking","type":"module"},{"doc":"Backtracking implementation for solving CSPs.OptionsThe following opts are supported:all, boolean, false by default: if only first, or all variables should be returned.ac3, boolean, false by default: if AC3 runs should be performed during each backtracking step.variable_selector, either :take_head (default), :minimum_remaining_values (will select the variable with the least values remaining in the domain as the next candidate to consider), or a function accepting a list of unassigned variables, and returning a tuple of a variable we should consider next and a rest of the unassigned variables list.","ref":"Csp.Backtracking.html#solve/2","title":"Csp.Backtracking.solve/2","type":"function"},{"doc":"","ref":"Csp.Backtracking.html#t:variable_selector/0","title":"Csp.Backtracking.variable_selector/0","type":"type"},{"doc":"Command line interface for constraint satisfaction.","ref":"Csp.CLI.html","title":"Csp.CLI","type":"module"},{"doc":"Usage:$ mix escript.build $ ./csp","ref":"Csp.CLI.html#main/1","title":"Csp.CLI.main/1","type":"function"},{"doc":"","ref":"Csp.CLI.html#trial_map_coloring_problem/0","title":"Csp.CLI.trial_map_coloring_problem/0","type":"function"},{"doc":"","ref":"Csp.CLI.html#trial_n_queens_problem/0","title":"Csp.CLI.trial_n_queens_problem/0","type":"function"},{"doc":"","ref":"Csp.CLI.html#trial_squares_problem_brute_force_part/1","title":"Csp.CLI.trial_squares_problem_brute_force_part/1","type":"function"},{"doc":"A constraint protocol: allows defining custom constraints that can be used as part of Csp structs.Provided implementationA default impelementation is provided. It implements this protocol for tuple of a list of variables (arguments of the constraint), and a function accepting values of those variables (in the same order as they are specified in the first element of the tuple) returning if the constraint is satisifed by those values of the variables.For example, this is a constraint that asserts that variables :a and :b should not be equal:{[:a, :b], fn a, b -&gt; a != b end}","ref":"Csp.Constraint.html","title":"Csp.Constraint","type":"protocol"},{"doc":"Returns a list of variables - arguments that this constraint uses.","ref":"Csp.Constraint.html#arguments/1","title":"Csp.Constraint.arguments/1","type":"function"},{"doc":"Checks if constraint is satisfied by assignment.","ref":"Csp.Constraint.html#satisfies?/2","title":"Csp.Constraint.satisfies?/2","type":"function"},{"doc":"","ref":"Csp.Constraint.html#t:t/0","title":"Csp.Constraint.t/0","type":"type"},{"doc":"Defines commonly used constraints.","ref":"Csp.Constraints.html","title":"Csp.Constraints","type":"module"},{"doc":"Creates a list of binary constraints that define that all variables in the variables list are different.","ref":"Csp.Constraints.html#all_different_constraints/1","title":"Csp.Constraints.all_different_constraints/1","type":"function"},{"doc":"Commonly used domains definitions.","ref":"Csp.Domains.html","title":"Csp.Domains","type":"module"},{"doc":"Defines a domain = [true, false].","ref":"Csp.Domains.html#boolean_domain/0","title":"Csp.Domains.boolean_domain/0","type":"function"},{"doc":"Defines a domain = [1, 2, ..., 9].","ref":"Csp.Domains.html#digit_domain/0","title":"Csp.Domains.digit_domain/0","type":"function"},{"doc":"Defines a domain = [0, 1, ..., 9].","ref":"Csp.Domains.html#digit_domain_from_zero/0","title":"Csp.Domains.digit_domain_from_zero/0","type":"function"},{"doc":"Min-conflicts algorithm implementation, with Tabu search to allow overcoming local minimums.","ref":"Csp.MinConflicts.html","title":"Csp.MinConflicts","type":"module"},{"doc":"Solves csp with min-conflicts algorithm, using tabu search to overcome local minimums.OptionsSupported opts::max_iteration - positive integer, the number of iteration to perform before giving up. Defaults to 10_000.:optimize_initial_state - boolean, defaults to false. If set to true, will use a greedy algorithm to set an initial state minimizing the number of conflicts for each variable.:tabu_depth - positive integer or nil, defaults to nil. If set to an integer, will limit tabu stack depth by the specified integer.","ref":"Csp.MinConflicts.html#solve/2","title":"Csp.MinConflicts.solve/2","type":"function"},{"doc":"Test constraint satisfaction problems.","ref":"Csp.Problems.html","title":"Csp.Problems","type":"module"},{"doc":"Returns an instance of a constraint satisfaction problem for map coloring of Australian states.","ref":"Csp.Problems.html#map_coloring/0","title":"Csp.Problems.map_coloring/0","type":"function"},{"doc":"Returns an example of a correct solution of the map coloring Csp.","ref":"Csp.Problems.html#map_coloring_example_solution/0","title":"Csp.Problems.map_coloring_example_solution/0","type":"function"},{"doc":"Returns an example of a wrong solution of the map coloring Csp.","ref":"Csp.Problems.html#map_coloring_wrong_solution/0","title":"Csp.Problems.map_coloring_wrong_solution/0","type":"function"},{"doc":"Returns an instance of N-queens problem for the specified n.The variables in the returned CSP are queen rows (1-indexed); domains are corresponding columns (also 1-indexed). E.g., 2 =&gt; 4 assignment means that the queen is positioned on the row 2 and column 4.To solve this, we suggest running the following:alias Csp.{Problems, Searcher} queens8 = nqueens() Searcher.backtrack(queens8)","ref":"Csp.Problems.html#nqueens/1","title":"Csp.Problems.nqueens/1","type":"function"},{"doc":"Returns an instance of N-queens problem for the specified n. Note, that this returns a more complicated representation of N Queens problem: this is useful for demonstrating representation-dependence of the problem solving performance only.The second argument determines the way we constraint the number of queens that we require to be placed on the board:true (default) will use 8 row constraints, saying that each row should have exactly one queenfalse will use a global constraint on all cells, saying that we should have exactly n queens.They are semantically equivalent, but may lead to different performance for solvers. Perhaps counterintuitevely, at least for backtracking it's easier to solve the problem with row-based placement constraints (even though we have more constraints in total), since we find inconsistencies earlier.The variables in the returned CSP are cell coordinates (0-indexed, {row, column}); domains are boolean (true if a queen is placed in the corresponding cell).To solve this, we suggest running the following:alias Csp.{Problems, Searcher} queens8 = nqueens_slow() Searcher.backtrack(queens8)","ref":"Csp.Problems.html#nqueens_slow/2","title":"Csp.Problems.nqueens_slow/2","type":"function"},{"doc":"Pretty-prints an N Queens problem solution represented as row to column associations (generated by nqueens/1).","ref":"Csp.Problems.html#pretty_print_nqueens/2","title":"Csp.Problems.pretty_print_nqueens/2","type":"function"},{"doc":"Pretty-prints an N Queens problem solution represented as cell assignments (generated by nqueens_slow/2).","ref":"Csp.Problems.html#pretty_print_nqueens_slow/2","title":"Csp.Problems.pretty_print_nqueens_slow/2","type":"function"},{"doc":"Pretty prints a prefilled or solved Sudoku from sudoku_cells_map, mapping cell coordinates to values.","ref":"Csp.Problems.html#pretty_print_sudoku/1","title":"Csp.Problems.pretty_print_sudoku/1","type":"function"},{"doc":"Returns an example Csp struct for the following problem:Y = X ^ 2 where X, Y are &gt;= 0 and &lt;= `max_value`max_value defaults to 9.","ref":"Csp.Problems.html#squares/1","title":"Csp.Problems.squares/1","type":"function"},{"doc":"Defines a Sudoku puzzle, with prefilled map of unary constraints for prefilled variables.prefilled should be a map matching cell coordinates (expressed as tuples {row, column}, with 0-indexed rows and column) to theire prefilled values.","ref":"Csp.Problems.html#sudoku/1","title":"Csp.Problems.sudoku/1","type":"function"},{"doc":"Returns a CSP corresponding to the example Sudoku from Wikipedia.","ref":"Csp.Problems.html#wiki_sudoku/0","title":"Csp.Problems.wiki_sudoku/0","type":"function"},{"doc":"A cells map of prefilled values from an example Sudoku from Wikipedia.","ref":"Csp.Problems.html#wiki_sudoku_cells_map/0","title":"Csp.Problems.wiki_sudoku_cells_map/0","type":"function"},{"doc":"","ref":"Csp.Problems.html#t:sudoku_cells_map/0","title":"Csp.Problems.sudoku_cells_map/0","type":"type"},{"doc":"Search strategies for CSP.","ref":"Csp.Searcher.html","title":"Csp.Searcher","type":"module"},{"doc":"Performs a brute force search on csp.NOTE: don't use it for real stuff. This is provided only for comparison with backtracking. Use backtracking instead!If solution is found, returned {:solved, assignment | assignments}, otherwise returns :no_solution.Optionsall, boolean: if all solutions should be found. By default is set to false, so only the first found solution is returned. If all is true, all solutions are found, and instead of returning a single assignment, returns a list of assignments.","ref":"Csp.Searcher.html#brute_force/2","title":"Csp.Searcher.brute_force/2","type":"function"}]